//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <algorithm>

#include <albus_log.h>

#include "String.h"


vector<string> Split( const string &sSplit, char delim ) {
vector<string> items;
string item;
stringstream ss ( sSplit );
    while ( getline ( ss, item, delim ) ) items.push_back ( item );

    return items;

}//


void ReplaceWhiteSpace ( std::string &str ) {

    D9 ( "str=~%s~", str.c_str() );

long strBeg = -1;
long strEnd = -1;
long strPos;
    for ( strPos = 0; strPos < str.length(); strPos++ ) {
	//D8 ( "str[%d]=~%c~", strPos, str[strPos] );
	if ( ( ( ' ' != str[strPos] ) && ( '\t' != str[strPos] ) ) && ( -1 == strBeg ) ) strBeg = strPos;
	if (   ( ' ' != str[strPos] ) && ( '\t' != str[strPos] )                       ) strEnd = strPos + 1;
    }
    if (    -1 == strBeg ) return;
    if (    -1 == strEnd ) return;
    if ( strBeg > strEnd ) return;
    D9 ( "strBeg=%04d strEnd=%04d", strBeg, strEnd );

    string oStr = "";
    oStr = str.substr ( strBeg, strEnd - strBeg );
    D9 ( "oStr=~%s~", oStr.c_str() );

    str  = oStr;
    D9 ( "str=~%s~", str.c_str() );

}//void ReplaceWhiteSpace ( std::string &str )


void Replace ( std::string &str, const std::string &strOut, const std::string& str_In ) {
    if ( ! strOut.length() ) return;
int pos = 0;
    while ( ( pos = str.find ( strOut, pos ) ) != std::string::npos ) {
	str.replace ( pos, strOut.length(), str_In );
	pos += str_In.length ();
    }
}//void Replace ( std::string &str, const std::string &strOut, const std::string& str_In )


_KeyIdxVal::_KeyIdxVal ( const string &Line ) {
    Key =   "";
    Idx = NULL;
    Val =   "";

int  CpyPos = Line.find ( '.', 0 );

    if ( CpyPos > Line.find ( '=', 0 ) ) CpyPos = Line.find ( '=', 0 );
    //printf ( "CpyPos=%d\n", CpyPos );
    if ( -1 < CpyPos ) {
	Key = Line.substr ( 0, CpyPos     );
	Val = Line.substr (    CpyPos + 1 );
    }
    else {
	Key = Line;
    }

    CpyPos = Key.find ( '[', 0 );
    if ( -1 < CpyPos ) {
    string Buffer = Key;
	Key   = Buffer.substr ( 0, CpyPos     );
    string sIndex  = Buffer.substr ( CpyPos     );
	Replace ( sIndex, "[", "" );
	Replace ( sIndex, "]", "" );
	Idx  = (long *)malloc ( sizeof ( long ) );
	*Idx  = atol ( sIndex.c_str() );
    }
    ReplaceWhiteSpace ( Key );
    ReplaceWhiteSpace ( Val );

}//_KeyIdxVal::_KeyIdxVal ( const string &Line )


string File2String ( string &File ) {
string   txString;
ifstream rxFile;
string   rxLine;

    rxFile.open ( File.c_str () );
    while ( std::getline ( rxFile, rxLine ) ) txString+= rxLine + "\n";

    return txString;

}//string File2String ( string &File )


vector<_KeyIdxVal> String2KeyIdxVal ( string &rxString ) {
vector<_KeyIdxVal> KeyIdxVal;
string             rxLine;
stringstream       ssString ( rxString );

    while ( std::getline ( ssString, rxLine, '\n' ) ) {
	if (  !     rxLine.size ()    ) continue;
	if ( '#' == rxLine.c_str()[0] ) continue;
	//D8 ( "Line=~%s~", rxLine.c_str() );
    _KeyIdxVal Config = _KeyIdxVal ( rxLine );
	KeyIdxVal.push_back ( Config );
	//D8 ( "Key=~%s~ Idx=~%p~ Val=~%s~", Config.Key.c_str(), Config.Idx, Config.Val.c_str() );
	//if ( Config.Idx ) D8 ( "Config.Idx=%ld" , *Config.Idx );
    }//while ( std::getline ( File, Line ) )

    return KeyIdxVal;

}//vector<_KeyIdxVal> String2KeyIdxVal ( string &rxString )


vector<string> ReadDir ( const string &rDir, long rFlags, long rSort ) {
vector<string> items;

    D9 ( "rFlags=%x", rFlags );
    D9 ( "rSort =%x", rSort  );

DIR *OpenDir = opendir ( rDir.c_str() );
    if ( ! OpenDir ) return items;

struct dirent *ReadDir;
    while ( ( ReadDir = readdir ( OpenDir ) ) != NULL ) {
	if      ( strcmp ( "." , ReadDir->d_name ) == 0 ) continue;
	else if ( strcmp ( "..", ReadDir->d_name ) == 0 ) continue;
	items.push_back ( ReadDir->d_name );
    }

    closedir ( OpenDir );

//sort
    sort ( items.begin(), items.end() );
    if ( RD_DESC & rSort ) reverse ( items.begin(), items.end() );

    return items;

}//vector<string> ReadDir ( const string &rDir, long rFlags )


string usec2string ( string sSec ) {
    return usec2string( atol( sSec.c_str() ) );
}//string usec2string ( string sSec )


string usec2string ( long   lSec ) {
struct tm *TM = localtime ( &lSec );
char xheader[255] = "";
    strftime ( xheader, 80, "%d.%m.%Y %X", TM );
string usec = xheader;
    return usec;
}//string usec2string ( long   lSec )
