//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifdef __cplusplus
extern "C" {
#endif
#ifndef _albus_log_h
#define _albus_log_h
#include <stdlib.h>
//#include <json-c/json.h>

#define AL_ER 0x0F
#define AL_D1 0x01
#define AL_D2 0x02
#define AL_D3 0x03
#define AL_D4 0x04
#define AL_D5 0x05
#define AL_D6 0x06
#define AL_D7 0x07
#define AL_D8 0x08
#define AL_D9 0x09

#define ModulNme NULL
#define ER(a01,...)  { albus_log ( AL_ER, Error, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define SER(a01,...) { albus_log ( AL_ER, Error, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); return NULL; }
#define EX(a01,...)  { albus_log ( AL_ER,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); exit (1); }
//efine EX(a01,...)  { albus_log ( AL_ER,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D1(a01,...)  { albus_log ( AL_D1,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D2(a01,...)  { albus_log ( AL_D2,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D3(a01,...)  { albus_log ( AL_D3,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D4(a01,...)  { albus_log ( AL_D4,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D5(a01,...)  { albus_log ( AL_D5,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D6(a01,...)  { albus_log ( AL_D6,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D7(a01,...)  { albus_log ( AL_D7,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D8(a01,...)  { albus_log ( AL_D8,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define D9(a01,...)  { albus_log ( AL_D9,  NULL, ModulNme, (char *)__FUNCTION__, __LINE__, a01, ## __VA_ARGS__ ); }
#define PFL          { albus_log ( AL_D8,  NULL, ModulNme,                 NULL,        0, "%50s[%04d]", __FUNCTION__, __LINE__ ); }
#ifdef DEBUG
#	define PFLID PFL
#else
#	define PFLID
#endif
//ER ( "E1 sylog--- string=%s long=%ld---", "bbb", -23 );
//D3 ( "D3 1 sylog--- string=%s long=%ld---", "bbb", -23 );
//D3 ( "D3 2 sylog--- string=%s long=%ld---main=0x%08X", "bbb", -23, -43 );
//albus_log ( AL_ER, __PRETTY_FUNCTION__, __LINE__,  "ER sylog--- string=%s long=%ld---", "bbb", -23 );
//albus_log ( AL_D3, __PRETTY_FUNCTION__, __LINE__,  "D3 sylog--- string=%s long=%ld---", "bbb", -23 );

//void albus_log_cmd_cb ( void *address, char *Key, char *Val, json_object **Sub, json_object **obj_tx, json_object **obj_rx );
void albus_log        ( int l_level, char *Error, char *Modul, const char *Function, long FunctionLine, const char *format, ... );
char *albus_log_set ( const char *Key, const char *Val );

#endif
#ifdef __cplusplus
}
#endif
