//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define	DEBUG
#include <stdio.h>

#include <String.h>
#include <albus_log.h>
#include <heat_masterd.h>

#include "dlbus.h"


char *_dlbuss::Set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val ) {
    D9 ( "Idx=~%p~ Key=~%s~ KeyIdx=~%p~ Val=~%s~", Idx, Key.c_str(), KeyIdx, Val.c_str() );
    if ( ! Idx ) SER ( "! Idx" );
    D9 ( "Idx=%ld" , *Idx );

    D9 ( "dlbus.size()=%d", dlbus.size () );
long dlbusMissing = *Idx + 1 - dlbus.size ();
    D9 ( "dlbusMissing=%ld", dlbusMissing );
    if ( 0 < dlbusMissing ) {
	while ( dlbusMissing ) {
	    D9 ( "add _dlbus" );
	_dlbus dlbus_new;
	    dlbus.push_back ( dlbus_new );
	    dlbusMissing--;
	}
    }//if ( 0 < dlbusMissing )

    if ( ! dlbus[ *Idx ].IdxSelf ) dlbus[ *Idx ].IdxSelf = new long;
          *dlbus[ *Idx ].IdxSelf = *Idx;
           dlbus[ *Idx ].Now     =  Now;

    if ( 1 == 0 ) {}
    else if ( "Host"  == Key ) dlbus[ *Idx ].Host = strdup ( Val.c_str() );
    else if ( "Port"  == Key ) dlbus[ *Idx ].Port = atol   ( Val.c_str() );
    else if ( "Index" == Key ) {
	if ( ! dlbus[ *Idx ].Index ) dlbus[ *Idx ].Index = new long;
	*dlbus[ *Idx ].Index = atol ( Val.c_str() );
    }

    return NULL;

}//char *_dlbus::Set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val )


char *_dlbuss::Loop  ( void ) {
PFLID

    D9 ( "dlbus.Status=%02X", Status );

    for ( long lPos = 0; lPos < dlbus.size (); lPos++ ) {
	if ( ( StatusSend & Status ) && ( ! ( StatusData & Status ) ) ) {
	              dlbus[lPos].Status  = StatusWait;
	              dlbus[lPos].Timeout = *Now + 2;
	    sprintf ( dlbus[lPos].txCmd   , "data" );
	}
	if ( StatusClear & Status ) dlbus[lPos].Status  = 0;
	D9 ( "dlbus[%04d].Status=%d", lPos, dlbus[lPos].Status );
    }//for ( long lPos = 0; lPos < dlbus.size (); lPos++ )

    Status = 0;
    for ( long lPos = 0; lPos < dlbus.size (); lPos++ ) {
	dlbus[lPos].Loop ();
	D9 ( "dlbus[%04d].Status=%d", lPos, dlbus[lPos].Status );
	Status |= dlbus[lPos].Status;

    //check Status, wait for all sub
	if ( ( ! ( StatusWait & Status ) ) && ( StatusData & Status ) ) {
	    if ( dlbus[lPos].Error[0] ) ER ( "dlbus[%d]=%s", lPos, dlbus[lPos].Error );
		 dlbus[lPos].Error[0] = 0;
	}

    }//for ( long lPos = 0; lPos < dlbus.size (); lPos++ )

    D9 ( "dlbus.Status=%02X", Status );

    return NULL;

}//char *_dlbuss::Loop  ( void )


char *_dlbuss::Close ( void ) {
PFLID
//2do
    return NULL;

}//char *_dlbuss::Close ( void )


char *_dlbus::Close( void ) {
PFLID
//2do
    return NULL;

}//char *_dlbus::Close( void )


char *_dlbus::Loop ( void ) {
PFLID

    if ( socClient.Error[0] ) socClient.Loop ();

    if ( Error[0] ) {
	rxCmd[0] = 0;
	txCmd[0] = 0;
	Status   = StatusData;
	return NULL;
    }
    if ( ( Now ) && ( StatusWait & Status ) ) {
	if ( ( *Now ) && ( Timeout ) ) {
	    if ( Timeout <= *Now ) {
		Timeout = 0;
		if ( socClient.Error[0] ) {
		    strcpy ( Error, socClient.Error );
		    return NULL;
		}
		SER ( "Timeout <= Now" );
	    }
	}
    }//if ( ( Now ) && ( ! Status ) )

    if ( ! InitDone ) {
	InitDone = 1;
	socClient.Listen = 0;//client
	socClient.Host   = Host;
	socClient.Port   = Port;
	socClient.Now    = Now;

    _fd_stack *fd_stack_new = &socClient.fd_stack[0];
	fd_stack_new->rx.malloc = 0x1FF;
	fd_stack_new->rx.data = (unsigned char *)malloc ( fd_stack_new->rx.malloc );
	fd_stack_new->tx.malloc = 0x1FF;
	fd_stack_new->tx.data = (unsigned char *)malloc ( fd_stack_new->tx.malloc );
	return socClient.Loop ();//start client
    }//if ( ! InitDone )

_fd_stack *fd_stack_new = &socClient.fd_stack[0];
    if ( 999 < CmdCnt ) CmdCnt= 0;
    if ( ! fd_stack_new->tx.len ) {
	if ( txCmd[0] && ! rxCmd[0] ) {
	    memset ( fd_stack_new->tx.data, 0, fd_stack_new->tx.malloc );
	             fd_stack_new->tx.len = strlen ( txCmd );
	    memcpy ( fd_stack_new->tx.data, txCmd, fd_stack_new->tx.len );
	    D9 ( "cl_tx=~%s~", fd_stack_new->tx.data );
	    strcpy ( rxCmd, txCmd );
	}
    }//if ( ! fd_stack_new->tx.len )

    if ( fd_stack_new->rx.len ) {
	D9 ( "cl_rx=~%s~", fd_stack_new->rx.data );
	memcpy ( rxCmd, fd_stack_new->rx.data, fd_stack_new->rx.len );
	D9 ( "txCmd=~%s~", txCmd );
	D9 ( "rxCmd=~%s~", rxCmd );

	if ( ( Index ) && ( IdxSelf ) ) {
	    D9 ( "*Index=%d"  , *Index   );
	    D9 ( "*IdxSelf=%d", *IdxSelf );

	vector<string> Data = Split ( rxCmd, '\n' );
	    for ( unsigned int DataPos = 0; DataPos < Data.size(); DataPos++ ) {
	    long *rxIndex = NULL;
		D9 ( "Data[%d]=~%s~", DataPos, Data[DataPos].c_str() );

	    vector<string> Field = Split ( Data[DataPos], ',' );
		for ( unsigned int FieldPos = 0; FieldPos < Field.size(); FieldPos++ ) {
		    D9 ( "Field[%d]=~%s~", FieldPos, Field[FieldPos].c_str() );
		_KeyIdxVal KeyIdxVal ( Field[FieldPos] );
		    D9 ( "Key=~%s~ Val=~%s~", KeyIdxVal.Key.c_str(), KeyIdxVal.Val.c_str() );
		    if ( "usb_id" == KeyIdxVal.Key ) {
			if ( *Index == atol ( KeyIdxVal.Val.c_str() ) ) {
			    rxIndex = Index;
			    break;
			}
		    }
		}//for ( unsigned int FieldPos = 0; FieldPos < Field.size(); FieldPos++ )

		if ( ! rxIndex ) continue;

		for ( unsigned int FieldPos = 0; FieldPos < Field.size(); FieldPos++ ) {
		_KeyIdxVal KeyIdxVal ( Field[FieldPos] );
		    D9 ( "Key=~%s~ Val=~%s~", KeyIdxVal.Key.c_str(), KeyIdxVal.Val.c_str() );
		    HeatMasterMap ( "dlbus", IdxSelf, KeyIdxVal.Key.c_str(), KeyIdxVal.Val.c_str() );
		}//for ( unsigned int FieldPos = 0; FieldPos < Field.size(); FieldPos++ )

	    }//for ( unsigned int DataPos = 0; DataPos < Data.size(); DataPos++ )

	}//if ( ( Index ) && ( IdxSelf ) )

	rxCmd[0] = 0;
	txCmd[0] = 0;
	Status   = StatusData;
	fd_stack_new->rx.len = 0;
    }//if ( fd_stack_new->rx.len )

    return socClient.Loop ();

}//char *_dlbus::Loop ( void )
