//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define	DEBUG
#include <stdio.h>

#include <String.h>
#include <albus_log.h>
#include <heat_masterd.h>

#include "ebus.h"


char *_ebuss::Set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val ) {
PFLID
    D9 ( "Idx=~%p~ Key=~%s~ KeyIdx=~%p~ Val=~%s~", Idx, Key.c_str(), KeyIdx, Val.c_str() );
    if ( ! Idx ) SER ( "! Idx" );
    D9 ( "Idx=%ld" , *Idx );

    D9 ( "ebus.size()=%d", ebus.size () );
long ebusMissing = *Idx + 1 - ebus.size ();
    D9 ( "ebusMissing=%ld", ebusMissing );
    if ( 0 < ebusMissing ) {
	while ( ebusMissing ) {
	    D9 ( "add _ebus" );
	_ebus ebus_new;
	    ebus.push_back ( ebus_new );
	    ebusMissing--;
	}
    }//if ( 0 < ebusMissing )

    if ( ! ebus[ *Idx ].IdxSelf ) ebus[ *Idx ].IdxSelf = new long;
          *ebus[ *Idx ].IdxSelf = *Idx;
           ebus[ *Idx ].Now     =  Now;

    if ( 1 == 0 ) {}
    else if ( "Host"  == Key ) ebus[ *Idx ].Host = strdup ( Val.c_str() );
    else if ( "Port"  == Key ) ebus[ *Idx ].Port = atol   ( Val.c_str() );
    else if ( "Index" == Key ) {
	if ( ! ebus[ *Idx ].Index ) ebus[ *Idx ].Index = new long;
	*ebus[ *Idx ].Index = atol ( Val.c_str() );
    }

    return NULL;

}//char *_ebus::Set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val )


char *_ebuss::Loop  ( void ) {
PFLID

    D9 ( "ebus.Status=%02X", Status );

    for ( long lPos = 0; lPos < ebus.size (); lPos++ ) {
	if ( ( StatusSend & Status ) && ( ! ( StatusData & Status ) ) ) {
	              ebus[lPos].Status  = StatusWait;
	              ebus[lPos].Timeout = *Now + 2;
	    sprintf ( ebus[lPos].txCmd   , "find -d\n" );
	}
	if ( StatusClear & Status ) ebus[lPos].Status  = 0;
	D9 ( "ebus[%04d].Status=%d", lPos, ebus[lPos].Status );
    }//for ( long lPos = 0; lPos < ebus.size (); lPos++ )

    Status = 0;
    for ( long lPos = 0; lPos < ebus.size (); lPos++ ) {
	ebus[lPos].Loop ();
	D9 ( "ebus[%04d].Status=%d", lPos, ebus[lPos].Status );
	Status |= ebus[lPos].Status;

    //check Status, wait for all sub
	if ( ( ! ( StatusWait & Status ) ) && ( StatusData & Status ) ) {
	    if ( ebus[lPos].Error[0] ) ER ( "ebus[%d]=%s", lPos, ebus[lPos].Error );
		 ebus[lPos].Error[0] = 0;
	}

    }//for ( long lPos = 0; lPos < ebus.size (); lPos++ )

    D9 ( "ebus.Status=%02X", Status );

    return NULL;

}//char *_ebuss::Loop  ( void )


char *_ebuss::Close ( void ) {
PFLID
//2do
    return NULL;

}//char *_ebuss::Close ( void )


char *_ebus::Close( void ) {
PFLID
//2do
    return NULL;

}//char *_ebus::Close( void )


char *_ebus::Loop ( void ) {
PFLID

    if ( socClient.Error[0] ) socClient.Loop ();

    if ( Error[0] ) {
	rxCmd[0] = 0;
	txCmd[0] = 0;
	Status   = StatusData;
	return NULL;
    }
    if ( ( Now ) && ( StatusWait & Status ) ) {
	if ( ( *Now ) && ( Timeout ) ) {
	    if ( Timeout <= *Now ) {
		Timeout = 0;
		if ( socClient.Error[0] ) {
		    strcpy ( Error, socClient.Error );
		    return NULL;
		}
		SER ( "Timeout <= Now" );
	    }
	}
    }//if ( ( Now ) && ( ! Status ) )

    if ( ! InitDone ) {
	InitDone = 1;
	socClient.Listen = 0;//client
	socClient.Host   = Host;
	socClient.Port   = Port;
	socClient.Now    = Now;

    _fd_stack *fd_stack_new = &socClient.fd_stack[0];
	fd_stack_new->rx.malloc = 0x1FF;
	fd_stack_new->rx.data = (unsigned char *)malloc ( fd_stack_new->rx.malloc );
	fd_stack_new->tx.malloc = 0x1FF;
	fd_stack_new->tx.data = (unsigned char *)malloc ( fd_stack_new->tx.malloc );
	return socClient.Loop ();//start client
    }//if ( ! InitDone )

_fd_stack *fd_stack_new = &socClient.fd_stack[0];
    if ( 999 < CmdCnt ) CmdCnt= 0;
    if ( ! fd_stack_new->tx.len ) {
	if ( txCmd[0] && ! rxCmd[0] ) {
	    memset ( fd_stack_new->tx.data, 0, fd_stack_new->tx.malloc );
	             fd_stack_new->tx.len = strlen ( txCmd );
	    memcpy ( fd_stack_new->tx.data, txCmd, fd_stack_new->tx.len );
	    D9 ( "cl_tx=~%s~", fd_stack_new->tx.data );
	    strcpy ( rxCmd, txCmd );
	}
    }//if ( ! fd_stack_new->tx.len )

    if ( fd_stack_new->rx.len ) {
	D9 ( "cl_rx=~%s~", fd_stack_new->rx.data );
	memcpy ( rxCmd, fd_stack_new->rx.data, fd_stack_new->rx.len );
	D9 ( "txCmd=~%s~", txCmd );
	D9 ( "rxCmd=~%s~", rxCmd );

	if ( ( Index ) && ( IdxSelf ) ) {
	    D9 ( "*Index=%d"  , *Index   );
	    D9 ( "*IdxSelf=%d", *IdxSelf );

	vector<string> Data = Split ( rxCmd, '\n' );
	    for ( unsigned int DataPos = 0; DataPos < Data.size(); DataPos++ ) {
	    long *rxIndex = Index;//2do find master
		D9 ( "Data[%d]=~%s~", DataPos, Data[DataPos].c_str() );
		if ( ! rxIndex ) break;

	    _KeyIdxVal KeyIdxVal ( Data[DataPos] );
		D9 ( "Key=~%s~ Val=~%s~", KeyIdxVal.Key.c_str(), KeyIdxVal.Val.c_str() );

	    vector<string> Val = Split ( KeyIdxVal.Val, ';' );
		D9 ( "Val.size()=%d", Val.size()  );
	    string ValMap;
		if ( 1 == 0 ) {}
	    //heatpump heatkwh = 141;11;04;3c;-1;0;0.2
	    //heatpump tqa = 80;1;1d;00;1;2065;0.0
	    //heatpump volume1 = 138;11;04;3c;-1;0;0.4
	    //heatpump volume2 = 134;11;0d;12;9999;0;530.4
	    //temperature water = 4;0;0d;02;1000;0;55.5
		else if ( KeyIdxVal.Key == "temperature water"   ) ValMap = Val[6];
	    //temperature outside = 0;0;0d;02;500;-500;7.5
		else if ( KeyIdxVal.Key == "temperature outside" ) ValMap = Val[6];
	    //temperature buffer = 96;0;0d;02;1000;0;27.5
		else if ( KeyIdxVal.Key == "temperature buffer"  ) ValMap = Val[6];
	    //heatpump mode = 53;1;00;00;255;0;Vorlaufzeit Heizbetrieb
		else if ( KeyIdxVal.Key == "heatpump mode"       ) ValMap = Val[6];
	    //master data1 = 27.500;-;0;0;0;1;0;0;0;10.898
	    //master data2 = 63.000;55.000;0;0;0
	    //master datetime = 7.500;10:26:43;03.12.2015
		else if ( KeyIdxVal.Key == "master datetime"     ) {
		    D9 ( "Val[1]=~%s~"   , Val[1].c_str() );//Time
		    D9 ( "Val[2]=~%s~"   , Val[2].c_str() );//Date
		static    tm gTM;
		    memset ( &gTM, 0, sizeof ( tm ) );
		    sscanf ( Val[2].c_str(), "%d.%d.%d" \
			, &gTM.tm_mday \
			, &gTM.tm_mon \
			, &gTM.tm_year );
		    sscanf ( Val[1].c_str(), "%d:%d:%d" \
			, &gTM.tm_hour \
			, &gTM.tm_min \
			, &gTM.tm_sec );
		//correction
		    gTM.tm_year -= 1900;
		    gTM.tm_mon  -= 1;
		    gTM.tm_isdst = -1;
		char rxSec[30] = "";
		    sprintf ( rxSec, "%ld", mktime ( &gTM ) );
		    D9 ( "rxSec=%s", rxSec );
		    ValMap = rxSec;
		}//else if ( Key == "master datetime "     )

		HeatMasterMap ( "ebus", IdxSelf, KeyIdxVal.Key.c_str(), ValMap.c_str() );

	    }//for ( unsigned int DataPos = 0; DataPos < Data.size(); DataPos++ )
	}//if ( ( Index ) && ( IdxSelf ) )

	rxCmd[0] = 0;
	txCmd[0] = 0;
	Status   = StatusData;
	fd_stack_new->rx.len = 0;
    }//if ( fd_stack_new->rx.len )

    return socClient.Loop ();

}//char *_ebus::Loop ( void )
