//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define DEBUG
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <libgen.h> //4 dirname !!!

#include <albus_log.h>
#include <String.h>
#include <GetEnv.h>

#include <dlbus.h>
#include <ebus.h>
#include <sispm.h>
#include <logic.h>
#include <heat_master.h>
#include <heat_master_server.h>

#include "heat_masterd.h"


extern int   albus_log_level;
extern char *albus_log_stdio;
extern int   albus_log_syslog;
extern char *albus_log_file;

char   Error[255]  = "";
long   loop_offset =  4;//sec wait until data @ server is up2date
long   intervall   = 60;
char   home[256]   = "";
char   node[256]   = "";
time_t now         =  0;
char   bin_home[256] = "";

_dlbuss             dlbuss;
_ebuss              ebuss;
_sispms             sispms;
_heat_master        heat_master;
_heat_master_server heat_master_server;
string              ShowSQLName;
string              ShowSQL;


vector <_HeatMasterMap> vHeatMasterMap;


char *heat_master_set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val ) {
    D9 ( "Idx=~%p~ Key=~%s~ KeyIdx=~%p~ Val=~%s~", Idx, Key.c_str(), KeyIdx, Val.c_str() );
    if ( Idx ) D9 ( "Idx=%ld" , *Idx );
    if ( KeyIdx ) D9 ( "KeyIdx=%ld" , *KeyIdx );

_KeyIdxVal src ( Val );
    D9 ( "src.Key=~%s~ src.KeyIdx=~%p~ src.Val=~%s~", src.Key.c_str(), src.Idx, src.Val.c_str() );
    if ( src.Idx ) {
	D9 ( "src.Idx=%ld" , *src.Idx );

    _HeatMasterMap HeatMasterMap_new;
	 HeatMasterMap_new.dstField  =     Key;
	 HeatMasterMap_new.srcDriver = src.Key;
	 HeatMasterMap_new.srcField  = src.Val;
	 HeatMasterMap_new.srcIdx    = (long *)malloc( sizeof( long ) );
	*HeatMasterMap_new.srcIdx    = *src.Idx;
	vHeatMasterMap.push_back ( HeatMasterMap_new );

    }//if ( src.Idx )

}//char *heat_master_set ( const std::string &Val, const std::string &Key )


vector <_HeatMasterMap> vHtmlMap;
char *html_set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val ) {
    D9 ( "Idx=~%p~ Key=~%s~ KeyIdx=~%p~ Val=~%s~", Idx, Key.c_str(), KeyIdx, Val.c_str() );

_KeyIdxVal src ( Val );
    D9 ( "src.Key=~%s~ src.KeyIdx=~%p~ src.Val=~%s~", src.Key.c_str(), src.Idx, src.Val.c_str() );

_HeatMasterMap HtmlMap_new;
    HtmlMap_new.dstField  =     Key;
    HtmlMap_new.srcDriver = src.Key;
    HtmlMap_new.srcField  = src.Val;
    vHtmlMap.push_back ( HtmlMap_new );

}//char *html_set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val )


char *HeatMasterMap ( const char *System, long *IdxSelf, const char *Field, const char *Value ) {

    if ( ! System  ) return NULL;
    if ( ! IdxSelf ) return NULL;
    if ( ! Field   ) return NULL;
    if ( ! Value   ) return NULL;

    D9 ( "System=~%s~ IdxSelf=%d Field=~%s~ Value=~%s~", System, *IdxSelf, Field, Value );

long mPos = 0;
    while ( mPos < vHeatMasterMap.size() ) {
	D9 ( "vHeatMasterMap.dstField=~%s~", vHeatMasterMap[mPos].dstField.c_str() );
	D9 ( "vHeatMasterMap.srcField=~%s~", vHeatMasterMap[mPos].srcField.c_str() );
	if ( System == vHeatMasterMap[mPos].srcDriver ) {
	    if ( *IdxSelf == *vHeatMasterMap[mPos].srcIdx ) {
		if ( Field == vHeatMasterMap[mPos].srcField ) {

		int VarTab_pos = 0;
		    while ( heat_master.VarTab[VarTab_pos].Name ) {
			D9 ( "VarTab[%d].Name=%s", VarTab_pos, heat_master.VarTab[VarTab_pos].Name );
			if ( heat_master.VarTab[VarTab_pos].Name == vHeatMasterMap[mPos].dstField ) {
			    D9 ( "Set VarTab[%d].Name=%s", VarTab_pos, heat_master.VarTab[VarTab_pos].Name );
			    if ( 1 == 0 ) {}
			    else if ( strcmp ( "long", heat_master.VarTab[VarTab_pos].Type) == 0 ) {
			    long *x = (long *)heat_master.VarTab[VarTab_pos].Address;
				 *x = atol ( Value );
			    }
			    else if ( strcmp ( "double", heat_master.VarTab[VarTab_pos].Type ) == 0 ) {
			    double *x = (double *)heat_master.VarTab[VarTab_pos].Address;
				   *x = atof ( Value );
			    }
			    else if ( strcmp ( "char", heat_master.VarTab[VarTab_pos].Type ) == 0 ) {
			    char *x = (char *)heat_master.VarTab[VarTab_pos].Address;
				    strcpy ( x, Value );
			    }
			}
			VarTab_pos++;
		    }//while ( heat_master.VarTab[VarTab_pos].Name )
		}
	    }
	}
	mPos++;
    }//while ( mPos < vHeatMasterMap.size() )

    return NULL;

}//char *HeatMasterMap ( const char *Field, const char *Value )


char *heat_masterd_set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val ) {
    D9 ( "Idx=~%p~ Key=~%s~ KeyIdx=~%p~ Val=~%s~", Idx, Key.c_str(), KeyIdx, Val.c_str() );

    if ( 1 == 0 ) {}
    else if ( "intervall" == Key ) intervall               = atol   ( Val.c_str() );
    else if ( "host"      == Key ) heat_master_server.host = strdup ( Val.c_str() );
    else if ( "port"      == Key ) heat_master_server.port = atol   ( Val.c_str() );
    else if ( "home"      == Key ) strcpy ( home, Val.c_str() );
    else if ( "node"      == Key ) strcpy ( node, Val.c_str() );

    return NULL;

}//char *heat_masterd_set ( const std::string &Val, const std::string &Key )


int main ( int argc, char *argv[] ) {
//albus_log_level = 8;
//albus_log_syslog = 1;
//albus_log_stdio = (char *)"stderr";
//D8 ( "START!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" );

    time ( &now );
    dlbuss.Now = &now;
    ebuss.Now  = &now;

    strcpy ( bin_home, dirname ( argv[0] ) );

string xConfig = "";
    if ( argv[1] ) xConfig = (string)argv[1];
    else           xConfig = "/etc/bn-heat_masterd.txt";

string sConfig = File2String ( xConfig );

vector<_KeyIdxVal> KeyIdxVal = String2KeyIdxVal ( sConfig );
    D9 ( "KeyIdxVal.size()=%d", KeyIdxVal.size() );
int KeyIdxValPos = 0;
    while ( KeyIdxValPos < KeyIdxVal.size() ) {
	D9 ( "KeyIdxVal[%d].Key=~%s~ Val=~%s~", KeyIdxValPos, KeyIdxVal[KeyIdxValPos].Key.c_str(), KeyIdxVal[KeyIdxValPos].Val.c_str() );
    _KeyIdxVal SubKIV = _KeyIdxVal ( KeyIdxVal[KeyIdxValPos].Val );
	if ( 1 == 0 ) {}
	else if ( "log"             == KeyIdxVal[KeyIdxValPos].Key ) albus_log_set    ( SubKIV.Key.c_str(), SubKIV.Val.c_str() );
	else if ( "heat_master"     == KeyIdxVal[KeyIdxValPos].Key ) heat_master_set  ( KeyIdxVal[KeyIdxValPos].Idx, SubKIV.Key, SubKIV.Idx, SubKIV.Val );
	else if ( "html"            == KeyIdxVal[KeyIdxValPos].Key ) html_set         ( KeyIdxVal[KeyIdxValPos].Idx, SubKIV.Key, SubKIV.Idx, SubKIV.Val );
	else if ( "bn-heat_masterd" == KeyIdxVal[KeyIdxValPos].Key ) heat_masterd_set ( KeyIdxVal[KeyIdxValPos].Idx, SubKIV.Key, SubKIV.Idx, SubKIV.Val );
	else if ( "dlbus"           == KeyIdxVal[KeyIdxValPos].Key ) dlbuss.Set       ( KeyIdxVal[KeyIdxValPos].Idx, SubKIV.Key, SubKIV.Idx, SubKIV.Val );
	else if ( "ebus"            == KeyIdxVal[KeyIdxValPos].Key ) ebuss.Set        ( KeyIdxVal[KeyIdxValPos].Idx, SubKIV.Key, SubKIV.Idx, SubKIV.Val );
	else if ( "sispm"           == KeyIdxVal[KeyIdxValPos].Key ) sispms.Set       ( KeyIdxVal[KeyIdxValPos].Idx, SubKIV.Key, SubKIV.Idx, SubKIV.Val );
	KeyIdxValPos++;
    }

    if ( ! node[0] ) strcat  ( node,                   GetEnv ( (char *)"HOST.DOMAIN" ) );
    if ( ! home[0] ) sprintf ( home, "%s/heat_master", GetEnv ( (char *)"HOME"        ) );
    mkdir   ( home, 777 );//2do error check
    D1 ( "node = ~%s~", node );
    D1 ( "home = ~%s~", home );
    D1 ( "bin_home = ~%s~", bin_home );

    if ( 2 > intervall ) {
	ER ( "2 > intervall = %d", intervall );
	intervall = 2;
    }
    if ( loop_offset >= intervall ) loop_offset = intervall - 1;
    D1 ( "intervall = %d"  , intervall   );
    D1 ( "loop_offset = %d", loop_offset );

    heat_master.VarTabFmt.Mode = VarTabFmtSQL;
    ShowSQL = heat_master.sprintf (); ShowSQL += "\r\n";

    heat_master.VarTabFmt.Mode  = VarTabFmtSQL;
    heat_master.VarTabFmt.Mode |= VarTabFmtName;
    ShowSQLName = heat_master.sprintf (); ShowSQLName += "\r\n";

    dlbuss.Status = StatusClear; dlbuss.Loop ();
     ebuss.Status = StatusClear;  ebuss.Loop ();

long   sec_last = 0;
    time ( &now );
    sec_last = now;
    while ( 1 ) {
	Error[0] = 0;
	D9 ( "while" );

    char Status = 0;
	if ( heat_master_server.host ) heat_master_server.Loop ();

	dlbuss.Loop (); D9 ( "dlbuss.Status=%02X", dlbuss.Status );
	Status |= dlbuss.Status;

	ebuss.Loop (); D9 ( "ebuss.Status=%02X", ebuss.Status );
	Status |= ebuss.Status;

	D9 ( "hm.Status=%02X", Status );
	if ( ( ! ( StatusWait & Status ) ) && ( StatusData & Status ) ) {
	    logic_Loop ();
	    sispms.Loop ();

		 dlbuss.Status   = StatusClear;
	    if ( dlbuss.Error[0] ) strcpy ( heat_master.error, dlbuss.Error );
		 dlbuss.Error[0] = 0;

		 ebuss.Status   = StatusClear;
	    if ( ebuss.Error[0] ) strcpy ( heat_master.error, ebuss.Error );
		 ebuss.Error[0] = 0;

	char *ShowStr   = NULL;
	    heat_master.VarTabFmt.Mode = VarTabFmtSQL;
	    ShowStr     = heat_master.sprintf ();
	    ShowSQL     = ShowStr; if ( ShowStr ) free ( ShowStr );

	    heat_master.VarTabFmt.Mode  = VarTabFmtSQL;
	    heat_master.VarTabFmt.Mode |= VarTabFmtName;
	    ShowStr     = heat_master.sprintf ();
	    ShowSQLName = ShowStr; if ( ShowStr ) free ( ShowStr );
	    D1 ( "%s", ShowSQL.c_str() );

	    ShowSQL     += "\r\n";
	    ShowSQLName += "\r\n";
	char fName[255];
	FILE *fID = NULL;
	    sprintf ( fName, "%s/heat_master-%ld.txt", home, now );
	    fID = fopen ( fName, "wt" ); fwrite ( ShowSQL.c_str(), 1, ShowSQL.length(), fID ); fclose ( fID );
	    sprintf ( fName, "%s/heat_master-last.txt", home );
	    fID = fopen ( fName, "wt" ); fwrite ( ShowSQL.c_str(), 1, ShowSQL.length(), fID ); fclose ( fID );
	    //break;//bug4debug
	}//if ( ( ! ( StatusWait & Status ) ) && ( StatusData & Status ) )

    //Start Trigger
	time ( &now );
	if ( ( ( now % intervall ) - loop_offset ) | ( sec_last == now ) ) {
	    usleep ( 200000 );
	    continue;
	}
	sec_last = now;
	D9 ( "Sample Start" );
    //Start Trigger done

	if ( ! Status ) {
	    dlbuss.Status = StatusSend;
	    ebuss.Status  = StatusSend;
		      heat_master.Clean ();
		      heat_master.usec = now;
	    strcpy (  heat_master.host, node );
	}
	else {
	    ER ( "set trigger" );
	}

	//break;//bug4debug

    }//while ( 1 )

    return 0;

}//int main ( int argc, char *argv[] )
