//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define	DEBUG
#include <stdio.h>
#include <unistd.h>

#include <String.h>
#include <albus_log.h>

#include <heat_master.h>

#include "sispm.h"


extern _heat_master        heat_master;


char *_sispms::Set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val ) {
PFLID
    D9 ( "Idx=~%p~ Key=~%s~ KeyIdx=~%p~ Val=~%s~", Idx, Key.c_str(), KeyIdx, Val.c_str() );
    if ( ! Idx ) SER ( "! Idx" );
    D9 ( "Idx=%ld" , *Idx );

    D9 ( "sispm.size()=%d", sispm.size () );
long sispmMissing = *Idx + 1 - sispm.size ();
    D9 ( "sispmMissing=%ld", sispmMissing );
    if ( 0 < sispmMissing ) {
	while ( sispmMissing ) {
	    D9 ( "add _sispm" );
	_sispm sispm_new;
	    sispm.push_back ( sispm_new );
	    sispmMissing--;
	}
    }//if ( 0 < sispmMissing )

    if ( 1 == 0 ) {}
    else if ( "serial_number"  == Key ) sispm[ *Idx ].serial_number = Val;
    else {
    string sVal = Val;
    vector<_KeyIdxVal> src = String2KeyIdxVal ( sVal );
    int VarTab_pos = 0;
	while ( heat_master.VarTab[VarTab_pos].Name ) {
	    D9( "VarTab[%d].Name=%s"   , VarTab_pos, heat_master.VarTab[VarTab_pos].Name    );
	    D9( "VarTab[%d].Type=%s"   , VarTab_pos, heat_master.VarTab[VarTab_pos].Type    );
	    D9( "VarTab[%d].Address=%p", VarTab_pos, heat_master.VarTab[VarTab_pos].Address );
	    if ( heat_master.VarTab[VarTab_pos].Name == src[0].Val ) {
		if ( strcmp ( "long", heat_master.VarTab[VarTab_pos].Type ) == 0 ) {
		    if ( 1 == 0 ) {}
		    else if ( "a1"  == Key ) sispm[ *Idx ].a1 = (long *)heat_master.VarTab[VarTab_pos].Address;
		    else if ( "a2"  == Key ) sispm[ *Idx ].a2 = (long *)heat_master.VarTab[VarTab_pos].Address;
		    else if ( "a3"  == Key ) sispm[ *Idx ].a3 = (long *)heat_master.VarTab[VarTab_pos].Address;
		    else if ( "a4"  == Key ) sispm[ *Idx ].a4 = (long *)heat_master.VarTab[VarTab_pos].Address;
		    break;
		}
	    }//if ( heat_master.VarTab[VarTab_pos].Name == src[0].Val )
	    VarTab_pos++;
	}//while ( heat_master.VarTab[VarTab_pos].Name )
    }

    return NULL;

}//char *_sispm::Set ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val )


char *_sispms::Loop  ( void ) {
PFLID

    for ( long lPos = 0; lPos < sispm.size (); lPos++ ) {
	sispm[lPos].Loop ();
    }
    return NULL;

}//char *_sispms::Loop  ( void )


char *_sispms::Close ( void ) {
PFLID
//2do
    return NULL;

}//char *_sispms::Close ( void )


char *_sispm::Close( void ) {
PFLID
//2do
    return NULL;

}//char *_sispm::Close( void )


char *_sispm::OnOff ( long *ooFlag, char ooLine ) {

char *SysOO       = (char *)"-f";//Off
    if ( ooFlag ) {
	if ( *ooFlag ) SysOO = (char *)"-o";//On
    }

string fSysErr = "/tmp/sispmctl.err.log";
string fSysOut = "/tmp/sispmctl.out.log";
char  SysCmd[255] = "";
    sprintf ( SysCmd, "sispmctl -D %s %s %d > %s 2> %s", serial_number.c_str(), SysOO, ooLine, fSysOut.c_str(), fSysErr.c_str() );
    D9 ( "SysCmd=~%s~", SysCmd );
    system ( SysCmd );

string sSysErr = File2String ( fSysErr );
    unlink ( fSysErr.c_str() );
    if ( sSysErr.length() ) {
	ER ( "sSysErr=~%s~", sSysErr.c_str() );
    }

string sSysOut = File2String ( fSysOut );
    unlink ( fSysOut.c_str() );
    D9 ( "sSysOut=~%s~", sSysOut.c_str() );

}//char *_sispm::OnOff ( long *ooFlag )


char *_sispm::Loop ( void ) {
PFLID
//sispmctl -s
    D9 ( "serial_number=~%s~", serial_number.c_str() );
    D9 ( "a1=%p a2=%p a3=%p a4=%p", a1, a2, a3, a4 );

    OnOff ( a1, 1 );
    OnOff ( a2, 2 );
    OnOff ( a3, 3 );
    OnOff ( a4, 4 );

//2do check status "sispmctl -nm all"

    return NULL;

}//char *_sispm::Loop ( void )
