//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef _sispm_H
#define _sispm_H

#include <string>
#include <vector>

using namespace std;


class _sispm {
public:
    char *Loop  ( void );
    char *Close ( void );

    char    Error[1024];
    string  serial_number;
    long   *a1;
    long   *a2;
    long   *a3;
    long   *a4;
    _sispm () {
	Error[0]      =    0;
	serial_number =   "";
	a1            = NULL;
	a2            = NULL;
	a3            = NULL;
	a4            = NULL;
    }

private:
    char *OnOff ( long *ooFlag, char ooLine );

};


class _sispms {
public:
    char *Loop  ( void );
    char *Close ( void );
    char *Set   ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val );

    char  Error[1024];
    vector<_sispm> sispm;
    _sispms () {
	Error[0] =    0;
    }

};


#endif
