//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//2do win32,android,osx
//2do @ open.socket read all rx.data ...
//#define	DEBUG
#include <albus_log.h>

#include "socket_tcp.h"


char *_socket_tcp::Close( void ) {
PFLID

#ifndef __MINGW_H
    shutdown ( sockDesc, SHUT_RDWR );//2do @ __MINGW_H
#endif
    //FD_CLR   ( sockDesc, &the_state );
    close    ( sockDesc ); //2do
               sockDesc = -1;
    //2do free ( (void **)&host );
    Error[0] = 0;

    return NULL;

}//char *_socket_tcp::Close( void )


char *_socket_tcp::Loop ( void ) {
PFLID

    if ( Now ) {
	if ( ( *Now ) & ( RetryNext ) ) {
	    if ( RetryNext <= *Now ) {
		Error[0] = 0;
	    }
	}
    }//if ( Now )

    if ( Error[0] ) return NULL;

    if ( -1 == sockDesc ) {
	if ( Listen ) return OpenServer ();
	else          return OpenClient ();
    }

    D9 ( "fd_last=%d sockDesc=%d", fd_last, sockDesc );

struct timeval timeout;
    timeout.tv_sec  = 0;
    timeout.tv_usec = 0;

fd_set fds_rx = the_state;
fd_set fds_tx = the_state;
    if ( ! Listen ) {//Client
	FD_ZERO (           &fds_rx );
	FD_SET  ( sockDesc, &fds_rx );
	FD_ZERO (           &fds_tx );
	FD_SET  ( sockDesc, &fds_tx );
	fd_last = sockDesc;
    }
int    Select = select ( fd_last + 1, &fds_rx, &fds_tx, NULL, &timeout );
    D9 ( "select=%03d", Select );
    if ( 0 == Select ) return NULL;//no data
    if ( 0  > Select ) {
	ER ( "0  > Select" );
	Close();
	//2do reconnect();
	return NULL;
    }

//accept
    if ( Listen ) {//Server
	if ( FD_ISSET ( sockDesc, &fds_rx ) ) {
	struct sockaddr_in sock;
#ifdef __MINGW_H
	int       socklen = 0;
#else
	socklen_t socklen = sizeof ( struct sockaddr_in );
#endif
	    int acceptRet = accept ( sockDesc, (struct sockaddr *) &sock, &socklen );
	    if ( acceptRet < 0 ) return NULL;//2do SER
	//new client
	    D2 ( "accept=%03d", acceptRet );
	    FD_SET ( acceptRet, &the_state );
	    if ( acceptRet > fd_last ) {
		fd_last = acceptRet;
	    }//if ( acceptRet > fd_last )
	}//if ( FD_ISSET ( proxy->sockDesc, &fds_rx ) )
    }//if ( Listen )
//accept done

int fd_rx;
int fd_beg = sockDesc + 1;
int fd_end = fd_last;
    if ( ! Listen ) {//Client
	fd_beg = sockDesc;
	fd_end = sockDesc;
    }
    for ( fd_rx = fd_beg; fd_rx <= fd_end; ++fd_rx ) {
	D9 ( "fd_rx=%03d, rx=%d, tx=%d", fd_rx, FD_ISSET ( fd_rx, &fds_rx ), FD_ISSET ( fd_rx, &fds_tx ) );
    _fd_stack *fd_stack_new = &fd_stack[fd_rx];//2do, bug fd_stack pos via index from 0-n
	if ( ! Listen ) {//Client
	    fd_stack_new = &fd_stack[0];
	}
	if ( FD_ISSET ( fd_rx, &fds_rx ) ) {
	    if ( fd_stack_new->rx.data ) {
		if ( ! fd_stack_new->rx.len ) {
		    memset ( fd_stack_new->rx.data, 0, fd_stack_new->rx.malloc );
		    fd_stack_new->rxLen = read ( fd_rx, fd_stack_new->rx.data, fd_stack_new->rx.malloc );
		    D9 ( "fd_rx=%03d rxLen=%06d", fd_rx, fd_stack_new->rxLen );
		    if ( 0 >= fd_stack_new->rxLen ) {
			D2 ( "close=%03d", fd_rx );
			close  ( fd_rx );
			FD_CLR ( fd_rx, &the_state );
		    }
		    else {
			fd_stack_new->rx.len = fd_stack_new->rxLen;
		    }
		}
	    }
	}//if ( FD_ISSET ( fd_rx, &fds_rx ) )
	if ( FD_ISSET ( fd_rx, &fds_tx ) ) {
	    if ( fd_stack_new->tx.data ) {
		if ( fd_stack_new->tx.len ) {
		    fd_stack_new->txLen = write ( fd_rx, fd_stack_new->tx.data, fd_stack_new->tx.len );
		    D9 ( "fd_rx=%03d txLen=%06d", fd_rx, fd_stack_new->txLen );
		    if ( fd_stack_new->txLen != fd_stack_new->tx.len ) {
			D2 ( "close=%03d", fd_rx );
			close  ( fd_rx );
			FD_CLR ( fd_rx, &the_state );
		    }
		    else {
			fd_stack_new->tx.len = 0;
		    }
		    if ( fd_stack_new->Close ) {
			D2 ( "close=%03d", fd_rx );
			close  ( fd_rx );
			FD_CLR ( fd_rx, &the_state );
		    }
		}
	    }
	}
    }//for ( fd_rx = sockDesc + 1; fd_rx <= fd_last; ++fd_rx )

    return NULL;

}//char *_socket_tcp::Loop ( void )


char *_socket_tcp::OpenClient ( void ) {
PFLID

    if ( -1 != sockDesc ) return NULL;//already open
    if ( Error[0]       ) return NULL;
if ( ! Now  ) SER ( "! Now"  );
    if ( ! Host ) SER ( "! Host" );
    if ( ! Port ) SER ( "! Port" );

#ifdef __MINGW_H
static sk_init_done = 0;
    if ( ! sk_init_done ) {
	sk_init();
	sk_init_done = 1;
	//printf ( "p_gethostbyname = %x\n", p_gethostbyname );
    }
    //if ( ! p_gethostbyname ) return NULL; //2do
#endif

    if ( ! hostbyname ) {
	   hostbyname = gethostbyname ( Host );
    }
    if ( ! hostbyname ) {
	ER ( "! hostbyname = %s", Host );
	RetryNext = (*Now) + Retry;
	return NULL;
    }

    if ( ! Sockaddr ) {
		 Sockaddr = ( struct sockaddr_in *)malloc ( sizeof( struct sockaddr_in ) );
	memset ( Sockaddr, 0, sizeof( struct sockaddr_in ) );
		 Sockaddr->sin_family      = AF_INET;
		 Sockaddr->sin_addr.s_addr = *( (unsigned long *)hostbyname->h_addr_list[0] );
		 Sockaddr->sin_port        = htons ( Port );
    }//if ( ! Sockaddr )
    if ( ! Sockaddr ) SER ( "! Sockaddr" );

    if ( sockDesc < 0 ) {
	//ckDesc = socket ( AF_INET, SOCK_DGRAM , IPPROTO_UDP );
	sockDesc = socket ( PF_INET, SOCK_STREAM, IPPROTO_TCP );
	if ( sockDesc < 0 ) SER ( "sockDesc < 0" );
	D9 ( "sockDesc=%d\n", sockDesc );
    long connectRet = connect ( sockDesc, (struct sockaddr *)Sockaddr, sizeof( struct sockaddr_in ) );
	if ( connectRet < 0 ) {
	    RetryNext = (*Now) + Retry;
	    close ( sockDesc );
		    sockDesc = -1;
	    SER ( "Host %s:%d offline", Host, Port );
	}
	else {
	    D1 ( "Host %s:%d connection ok", Host, Port );
	}
    }//if ( sockDesc < 0 )

//non-blocking
#ifdef __MINGW_H
u_long iMode = 1;
    ioctlsocket   ( sockDesc, FIONBIO, &iMode );
#else
int flags = fcntl ( sockDesc, F_GETFL, 0 );
            fcntl ( sockDesc, F_SETFL, flags | O_NONBLOCK );
    flags = fcntl ( sockDesc, F_GETFL, 0);
#endif
//non-blocking done

    return NULL;

}//char *_socket_tcp::OpenClient ( void )


char *_socket_tcp::OpenServer ( void ) {
PFLID

    if ( -1 != sockDesc ) return NULL;//already open
    if ( Error[0]       ) return NULL;
    if ( ! Host ) SER ( "! Host" );
    if ( ! Port ) SER ( "! Port" );

    sockDesc = socket ( PF_INET, SOCK_STREAM, IPPROTO_TCP );
    //ckDesc = socket ( PF_INET, SOCK_DGRAM , IPPROTO_UDP );//connection-less
    if ( sockDesc < 0 ) SER ( "sockDesc = %d < 0", sockDesc );

//supress address already in use
char True = 1;
long setsockoptRet = setsockopt ( sockDesc, SOL_SOCKET, SO_REUSEADDR, &True, sizeof ( int ) );
    if ( 0 > setsockoptRet ) SER ( "0 > setsockoptRet" );

    hostbyname = gethostbyname( Host );
    if ( ! hostbyname ) SER ( "! hostbyname" );

    if ( ! Sockaddr ) {
             Sockaddr = ( struct sockaddr_in *)malloc( sizeof( struct sockaddr_in ) );
    }
    memset ( Sockaddr, 0, sizeof( struct sockaddr_in ) );
             Sockaddr->sin_family      = AF_INET;
             Sockaddr->sin_addr.s_addr = *( (unsigned long *)hostbyname->h_addr_list[0] );
             Sockaddr->sin_port        = htons ( Port );

long  bindRet = bind ( sockDesc, (struct sockaddr *)Sockaddr, sizeof ( struct sockaddr_in ) );
    if ( 0 != bindRet ) SER ( "0 != bindRet" );

int listenRet = listen ( sockDesc, Listen );
    if ( 0 > listenRet ) SER ( "0 > listenRet" );

    FD_ZERO (           &the_state );
    FD_SET  ( sockDesc, &the_state );
    fd_last = sockDesc;

    return NULL;

}//char *_socket_tcp::OpenServer ( void )
