//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef _socket_tcp_H
#define _socket_tcp_H

#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#ifndef __MINGW_H
//2do # include <sys/socket.h>
//2do # include <sys/select.h>
//2do # include <arpa/inet.h>
//2do # include <netinet/in.h>
# include <netdb.h>
#else
# include <winsock2.h>
# include <socket_tcp_dll.hpp>
#endif


typedef struct {
    unsigned long  len;
    unsigned long  malloc;
    unsigned char *data;
} _socket_blob;


#define fd_stack_max 20
typedef struct {
    _socket_blob  tx;
    unsigned long txLen;
    _socket_blob  rx;
    unsigned long rxLen;
    char Close;
} _fd_stack;


class _socket_tcp {
public:
    char *Loop  ( void );
    char *Close ( void );
    char                Error[1024];
    char               *Host;
    unsigned short      Port;
    unsigned short      Listen;
    int                 sockDesc;
    struct hostent     *hostbyname;
    struct sockaddr_in *Sockaddr;
    _fd_stack           fd_stack[fd_stack_max];
    fd_set              the_state;
    int                 fd_last;
    long  Retry;
    long  RetryNext;
    long  *Now;

    _socket_tcp () {
	Error[0]   =    0;
	Host       = NULL;
	Port       =    0;
	Listen     =    0;
	sockDesc   =   -1;
	hostbyname = NULL;
	Sockaddr   = NULL;
	memset ( fd_stack, 0, sizeof ( fd_stack ) );
	fd_last    =    0;
	Retry      =   30;
	RetryNext  =    0;
	Now        = NULL;
    }

private:
    char *OpenClient ( void );
    char *OpenServer ( void );
};

#endif
